//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon-Suk Lee (jl)
//  FILE: PCCond.C
//  PROJ: COKO
//  DATE: 10/9/96                                                              
//
// SYNOPSIS
// Class definitions for CCond.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCCCOND_C_
#define _PCCOND_C_

#include "PCCond.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CCond
// Parameters:	(char* a ... )
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CCond::CCond(char* a ... )
{
  va_list ap;
  va_start (ap,a);
  _condName = new char[strlen(a)+1];
  _varList = new NonTypeList();
  strcpy(_condName, a);

  _varcount = 0;
  _built_varcount = 0;

  for(;;)
	{
	  NonType* p = va_arg(ap, NonType*);
	  if (p == NULL) 
		break;
	  else 
		_varList->insert(p);
	  
	}
  va_end(ap);
  _varList->initIterator();
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CCond
// Parameters:	(void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CCond::~CCond(void)
{
  if (_varList) {delete _varList; _varList = NULL;}

  if (_condName) {delete _condName; _condName = NULL;}
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: build
// Parameters:	(CState*, NonType*)
//
// build environment.
//         								    
//////////////////////////////////////////////////////////////////////////////

CState* CCond::build(CState* s, NonType* nt)
{
  if ((_varList->iteratorValue()) && (_varList->iteratorValue())->isChildVar(_varList->iteratorValue()))
	{
	  if (!(s->IFind((_varList->iteratorValue())->Name())))
		s->IInsert((_varList->iteratorValue())->Name(), new CIdent( NULL, nt, 0));
	  
	  _varList->getValue();
	  // advances an iterator. Return value is ignored
	  
	  _built_varcount++;
	}
  else
	_varList->getValue();

  return s;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: allDone
// Parameters:	(void)
//
// are all variables built yet?
//         								    
//////////////////////////////////////////////////////////////////////////////

int CCond::allDone(void)
{
  if (_varcount == _built_varcount)
	return 1;
  else
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters:	(CState*)
//
// What to do when executed.
//         								    
//////////////////////////////////////////////////////////////////////////////

CState* CCond::Exec(CState * s)
{
  if (_debug_)
 	cout << "-- CCond Begins" << endl;

  int i = 0;

  _varList->initIterator();

  while (_varList->iteratorValue())
	{
	  if ((_varList->iteratorValue())->isChildVar(_varList->iteratorValue())) 
		_varcount++;
	  
	  _varList->getValue();
	  // advances an iterator. Return value is ignored.
	}
  
  _varList->initIterator();
  
  if (_debug_)
 	cout << "-- CCond Ends" << endl;
  
  return s;  
}

#endif
