//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl@cs.brown.edu)
//  FILE: PCFalseStmt.C
//  PROJ: COKO
//  DATE: 6/10/97                                                              
//
// SYNOPSIS
//  Class definition for CFalseStmt class.
//  
//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include "PCState.H"
#include "PCStmt.H"
#include "PCFalseStmt.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CFalseStmt
// Parameters: (CStmt*)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CFalseStmt::CFalseStmt(CStmt* stmt)
{
  _stmt = stmt;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CFalseStmt
// Parameters: (void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CFalseStmt::~CFalseStmt(void)
{
  if(_stmt) { delete _stmt; _stmt = NULL;}
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters: (CState*)
//
// What to do when executed
// Execute _stmt then set _Success to false.
//
//////////////////////////////////////////////////////////////////////////////

CState* CFalseStmt::Exec(CState *s)
{
  s = _stmt->Exec(s);

  // set _Success to False 
  s->SetSuccess(F);

  return s;
}
