//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl), Kee-Eung Kim (kek)
//  FILE: PCIEnvStack.H
//  PROJ: COKO
//  DATE: 5/5/97
//
// SYNOPSIS
//  Classes for Stack. Each element in the stack
//  is another stack. (Stack of stack)
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCIENVSTACK_H_
#define _PCIENVSTACK_H_

#include "PCIEnv.H"
class CIEnv;
class CIEnvNodeType;

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CIEnvStackDataType
//
// SYNOPSIS
//  A class for definition of each element in the stack.
//  (Stack is implemented as a linked list.)
//
//////////////////////////////////////////////////////////////////////////////

class CIEnvStackDataType
{
public:
  CIEnv *_item;                
  // _item is also another stack structure.

  CIEnvStackDataType *_next;   
  // Next stack element.

  CIEnvStackDataType(CIEnv *); 
  // Constructor 

  ~CIEnvStackDataType();      
  // Destructor

};

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CIEnvStack
//
// SYNOPSIS
//  Stack class.
//
//////////////////////////////////////////////////////////////////////////////

class CIEnvStack
{
private:
  CIEnvStackDataType *_data;  
 // Pointer to the top element in the stack.

public:
  CIEnvStack();
  // Constructor.
  
  ~CIEnvStack();
  // Destructor.
  
  void push(CIEnv *);          
  // The "Push" operation on the stack.
  
  void pop(void); 
  // The "Pop" operation on the stack.
  
  CIEnv * top(void);
  // Returns the top element.

  CIEnvStackDataType * getData();
  // Returns _data.

  CIEnvNodeType* findNodeDeep(const char*);
  // search for the entire stack starting from the top.

  CIEnvNodeType* findNodeFromHere(const char*, CIEnvStackDataType*);
  // search the stack from the given starting point.
  void deleteNodeDeep(const char*);
  // find a node and delete it.
  // search for entire stack starting from the top.

};

#endif
