//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon Suk  Lee (jl)                                             
//  FILE: PCSQPrintStmt.C
//  PROJ: COKO
//  DATE: 7/98                                                   
//
// SYNOPSIS
// 
//  This class is a derived class from CStmt. It is used for coko language 
//  debugging purposes.
//  
//////////////////////////////////////////////////////////////////////////////

#include "PCSQPrintStmt.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CSQPrintStmt
// Parameters: (int, char *)       
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CSQPrintStmt::CSQPrintStmt(int which_print, char *iname):
  _iname(NULL)
{
  _which_print = which_print;
  if (iname)
  	{
  	  _iname = new char[strlen(iname)+1];
  	  strcpy(_iname, iname);
  	}
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CSQPrintStmt
// Parameters: (void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CSQPrintStmt::~CSQPrintStmt(void)
{
  if (_iname) { delete [] _iname; _iname = NULL; }
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters: (CState*)
//
// What to do when executed.
//         								    
//////////////////////////////////////////////////////////////////////////////

CState *CSQPrintStmt::Exec(CState *s)
{
  initstats ();
  if (_which_print == 1)
	{
	  CIdent * myNode;
	  if (_iname) 
		{ 
		  char * res = NULL;;
		  myNode = s->IFind(_iname);
		  koObject* tree = ((koObject*)(myNode->Child_Look_Up()))->obj();
		  res = tree->sql();
		  cout << res << endl;
		  if (tree) { delete tree; tree = NULL; }
		  if (res) { delete [] res; res = NULL; }		  
		}
	  else
		{
		  cout << "Warning @ PCSQPrintStmt : Exec" << endl;
		  cout << "Nothing to print out warning" << endl;
		}
	}
  else if (_which_print == 2)
	{
	  CIdent * myNode;
	  if (_iname) 
		{ 
		  char * res = NULL;;
		  myNode = s->IFind(_iname);
		  koBool* tree = ((koBool*)(myNode->Child_Look_Up()))->boo();
		  res = tree->sql();
		  cout << res << endl;
		  if (tree) { delete tree; tree = NULL; }
		  if (res) { delete [] res; res = NULL; }		  
		}
	  else
		{
		  cout << "Warning @ PCSQPrintStmt : Exec" << endl;
		  cout << "Nothing to print out warning" << endl;
		}
	}
  else if (_which_print == 3)
	{
	  NonType* tree = s->Store();
	  NameUnion* name_ = tree->Myname();
	  if (name_->tag == BNAME )
		{
		  char * res = NULL;;
		  koBool* tree2 = ((koBool*)tree)->boo();
		  res = tree2->sql();
		  cout << res << endl;
		  if (tree2) { delete tree2; tree2 = NULL; }
		  if (res) { delete [] res; res = NULL; }			  
		}
	  else if (name_->tag == ONAME)
		{
		  char * res = NULL;;
		  koObject* tree2 = ((koObject*)tree)->obj();
		  res = tree2->sql();
		  cout << res << endl;
		  if (tree2) { delete tree2; tree2 = NULL; }
		  if (res) { delete [] res; res = NULL; }	
		}
	  else
		cout << "Error @ PCSQPrintStmt.C : Current tree must be either object or bool" << endl;
	  delete name_;
	}

  s->SetSuccess(1);
  return s;
}
