//////////////////////////////////////////////////////////////////////////////
//
// NAME: Joon S. Lee (jl)
//
// FILE: PCStmt.C
// PROJ: COKO
// DATE: 5/5/97
//
// SYNOPSIS
//  Class definition for CStmt class.
//
//////////////////////////////////////////////////////////////////////////////

#include "PCStmt.H"

int _debug_ = 0;

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: updateDEP
// Parameters:	(char*, CState*, CIEnvStackDataType*, int)
//
// updates variable dependancy list
//         								    
//////////////////////////////////////////////////////////////////////////////

CState* CStmt::updateDEP(char* key, CState* s,CIEnvStackDataType* startingPt, int startFlag)
{

  CIEnvStackDataType* startingPt_next;
  
  if (startFlag == 1)
	startingPt = s->IEnv()->getData();
   
  if (startingPt)
	startingPt_next = startingPt->_next;
  else
	startingPt_next = NULL;


  CPattern* tmp_pattern;

  if (!s->IEnv()->top())
	{
	  cout << "Error @ CStmt : updateDEP" << endl;
	  cout << "Stack is empty error" << endl;
	  exit(1);
	}
  else
	{
	  
	  if (_debug_)
		cout << "updating begin with initial variable " << key << endl;
	  
	  CIEnvNodeType * tmpNode = s->IEnv()->findNodeFromHere(key, startingPt);

	  if (tmpNode)
		{
		  tmpNode->initIteratorDEP();
		  char* tmpchar = tmpNode->getValueDEP();
		  
		  if (_debug_)
			cout << key << " has " << tmpchar << endl;
		  
		  if (tmpchar) 
			{
			  tmp_pattern = s->GetPatternFromHere(tmpchar, startingPt_next);
			  if (_debug_)
				cout << tmpchar << " has pattern " << tmp_pattern->getNT()->representation(); 
			  if (tmp_pattern)
				{
				  CIdent * matchNode = s->IFindFromHere(tmpchar, startingPt_next);
				  
				  s = tmp_pattern->buildFromHere(s, startingPt);
				  
				  s->IModifyFromHere(tmpchar, 
									 s->Store(),
									 matchNode->Which(),
									 startingPt_next);
				}
			  else 
				{
				  cout << "Error @ CStmt : updateDEP" << endl;
				  cout << "Pattern is empty error" << endl;
				  exit(1);
				}
			  
			  s = updateDEP(tmpchar, s, startingPt_next, 0);
			}
  		  while (tmpchar)
  			{
  			  tmpchar = tmpNode->getValueDEP();
  			  if (tmpchar)
  				{
 				  tmp_pattern = s->GetPatternFromHere(tmpchar, startingPt_next);
  				  if (tmp_pattern)
  					{
  					  CIdent * matchNode = s->IFindFromHere(tmpchar, startingPt_next);
  					  s = tmp_pattern->buildFromHere(s, startingPt);
  					  s->IModifyFromHere(tmpchar, 
 										 s->Store(),
 										 matchNode->Which(),
 										 startingPt_next);
  					}
 				  s = updateDEP(tmpchar,s, startingPt_next, 0);
  				}
		  	}
		}
	}
  return s;
}
