/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)					 	 
// FILE: TYTTup.C
// PROJ: KOLA Parser, AQUA Translator
// DATE: 5/95
//
//////////////////////////////////////////////////////////////////////////////

#include "TYTTup.H"
#include "ENEnvironment.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TTup
// Parameters:	(TObj* t)							  
//
//  Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TTup::TTup (Environment *e)
{

    env = e;
    myname = TYPE_TUP;
    
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  TTup
// Parameters:	(TTup& other)
//
//  Copy Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TTup::TTup (TTup& other)
{

    env = new Environment (*(other . Env ()));
    myname = TYPE_TUP;

}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  ~TTup
// Parameters:	()
//
//  Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

TTup::~TTup ()
{

    delete env;
    
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  Copy
// Parameters:	()							  
//
//  Return copy of this as Bool
//         								    
//////////////////////////////////////////////////////////////////////////////

TObj* TTup::Copy ()
{

    return new TTup (*this);
    
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  representation
// Parameters:	()							  
//
//  return "Tup [one -> representation ()]"
//         								    
//////////////////////////////////////////////////////////////////////////////

char* TTup::representation ()
{

  Environment *nenv;
  nenv = new Environment();
  nenv = nenv->insert(env->reversed());
  //    Environment *nenv = new Environment () -> insert (env -> reversed ());
    char *or = nenv -> show ();
    char *res = new char [strlen (or) + strlen ("<<>>") + 1];
    sprintf (res, "<<%s>>", or);
    delete [] or;
    delete nenv;
    return res;
    
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  prolog
// Parameters:	()							  
//
//  return "Tup [one -> prolog ()]"
//         								    
//////////////////////////////////////////////////////////////////////////////

char* TTup::prolog ()
{
  return NULL;
}

#ifdef _PROLOG_
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  sp_prolog
// Parameters:	()
//
// Since C/C++ functions only have indirect access to Prolog terms 
// via SP_term_refs, we need to convert kola tree to SP_term_refs.
// Converted kola tree will get passed to prolog runtime system.
//
// See the Sicstus prolog version 3#6 manual for more detailed info on
// the usage of SP_term_refs and other prolog supplied methods.
//
//////////////////////////////////////////////////////////////////////////////

SP_term_ref TTup::sp_prolog ()
{
  return NULL;
}
#endif // _PROLOG_

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  sameas
// Parameters:	(TObj *other)							  
//
//  return "Tup [one -> representation ()]"
//         								    
//////////////////////////////////////////////////////////////////////////////

int TTup::sameas (TObj *other) {

    return (other -> Identity () == TYPE_ANY || (other -> Identity () == TYPE_TUP && env -> sameas (other -> asTup () -> Env ())));

}
